//
// PurpleBunny Google Gadget
// By Jerry Liu (jerry@purplebunny.com)
//
var poll = 60;		// in minutes - defaults to 60 minutes

plugin.SetFlags(gddPluginFlagNone, gddContentFlagHaveDetails);
utils.setInterval(OnTimer, 1000 * 60 * poll);  // check once every 'poll' mins
OnTimer();    // update with first set of items

function OnTimer() {
  var item = new CommentItem();
  item = null;
}

//---- A class to manage the requests and callbacks of an item
function CommentItem() {
  contentArea.RemoveAllContentItems();
  var http = new XMLHttpRequest();
  http.onreadystatechange = OnData;
  var tm2 = new Date();
  var url = "http://www.purplebunny.com/bbs/xindex2.php?t="+tm2.getUTCSeconds();

  http.open("GET", url, true);
  http.send();

  function OnData() {
    if (http.readyState == 4) { // completed?
      var doc = new DOMDocument();
      doc.loadXML(http.responseText);
      var elem = doc.getElementsByTagName("comment");
      if (elem != null && elem.length > 0) {
        var max = elem.length - 1;
        for(var z=max; z >= 0; z--) {
          var site, page, desc;
          var forumUrl, siteUrl, commentUrl, thumbnail, reply, view, last;
          for (var node = elem[z].firstChild; node != null; node = node.nextSibling) {
            if (node.nodeName == "site")
              site = node.firstChild.nodeValue;
            if (node.nodeName == "page")
              page = node.firstChild.nodeValue;
            if (node.nodeName == "forumUrl")
              forumUrl = node.firstChild.nodeValue;
            if (node.nodeName == "siteUrl")
              siteUrl = node.firstChild.nodeValue;
            if (node.nodeName == "commentUrl")
              commentUrl = node.firstChild.nodeValue;
            if (node.nodeName == "thumbnailUrl")
              thumbnail = node.firstChild.nodeValue;
            if (node.nodeName == "replyCount")
              reply = node.firstChild.nodeValue;
            if (node.nodeName == "viewCount")
              view = node.firstChild.nodeValue;
            if (node.nodeName == "lastPostTime")
              last = node.firstChild.nodeValue;
          }  
          var i;
          if (site != null) { 
            var curItem = null;
            curItem = new ContentItem();  
            curItem.layout = gddContentItemLayoutNews;
            curItem.onDetailsView = OnDetailsView;
            contentArea.AddContentItem(curItem, gddItemDisplayInSidebar);
            curItem.heading = page;
            curItem.source = site;
            // to show in details view
            curItem.snippet = "Replies      : " + reply + "\n" +
                              "Views        : " + view + "\n" +
                              "Last Comment : " + last;
            var tm = new Date(last);
            tm.setMinutes(tm.getMinutes() + tm.getTimezoneOffset());
            curItem.time_created = tm.getVarDate();
            curItem.open_command = commentUrl;
          }
        }
      }
      http = null;  
    }
  }
}

function OnDetailsView(item) {
  var obj = new Object();
  obj.title = item.heading;
  return obj;
}
